﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web.Security;
using FirstMVC.Controllers;
using System.Web.SessionState;

namespace FirstMVC
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapUpdateSessionRoute(
                "Default",                                              // Route name
                "{controller}/{action}/{id}",                           // URL with parameters
                new { controller = "Home", action = "Index", id = "" }  // Parameter defaults
            );

        }

        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);
        }

        protected void Session_Start()
        {
            Session["something"] = DateTime.Now;
        }

        protected void Application_Error(Object sender, EventArgs e)
        {
            if (HttpContext.Current.Error is NullReferenceException)
            {
                HttpContext ctx = HttpContext.Current;
                if (ctx.Session != null)
                {
                    if (ctx.Session.IsNewSession)
                    {
                        HttpCookie sessionCookie = ctx.Request.Cookies["ASP.NET_SessionId"];
                        if (sessionCookie != null)
                        {
                            string sessionValue = sessionCookie.Value;
                            if (!string.IsNullOrEmpty(sessionValue))
                            {
                                FormsAuthentication.SignOut();
                                HttpContext.Current.ClearError();
                                HttpContext.Current.Response.Redirect("/SessionTimeout");
                            }
                        }
                    }
                }
            }
        }
    }
}