﻿<%@ Control Language="C#" Inherits="System.Web.Mvc.ViewUserControl" %>
<%--
本用户控件专为更新Session，使其不过期。需要将本控件放到每个Master Page
本控件需要两个Javascript：jquery.js和jquery.cookie.js，请确保Master Page中引用了它们
--%>
<div id="divAutoUpdateSession" style="display: none;">
    <input type="hidden" id="sessionWindow" name="sessionWindow" value="<%= Session.Timeout %>" />

    <script type="text/javascript">
        var nsUpdateSession = {};

        // tool functions ========================================================Begin

        // 把毫秒转换为Date对象
        nsUpdateSession.ms2Time = function(ms) {
            var time = new Date();
            time.setTime(ms);
            return time;
        }

        // 看是否有别的窗口在更新
        nsUpdateSession.getIsUpdatingSession = function() {
            var isUpdatingSession = $.cookie(nsUpdateSession.IsUpdatingSessionCookieName);
            if (isUpdatingSession == null)
                isUpdatingSession = false;
            else
                isUpdatingSession = (isUpdatingSession.toString().toLowerCase() == "true");
            return isUpdatingSession;
        }

        // 客户端时间转换为服务器端时间（毫秒）
        nsUpdateSession.client2ServerTime = function(clientTime) {
            var serverTimeMs = clientTime.getTime() - nsUpdateSession.timeBetweenServerAndClient;
            return serverTimeMs;
        }

        // 获取还有多长时间超时（毫秒）
        nsUpdateSession.getLeftMs = function() {
            var lustMs = nsUpdateSession.getLastUpdateSessionTimeMs();
            var outMs = lustMs + nsUpdateSession.sessionWindow;
            var nowMs = nsUpdateSession.client2ServerTime(new Date());
            var leftMs = outMs - nowMs;
            return leftMs;
        }

        // 获取最后更新Session的时间（毫秒）
        nsUpdateSession.getLastUpdateSessionTimeMs = function() {
            var serverTimeStr = $.cookie(nsUpdateSession.LastUpdateSessionTimeCookieName);
            var serverTimeMs = parseInt(serverTimeStr);
            return serverTimeMs;
        }

        // 获取最后更新Session的日期时间，返回Date对象
        nsUpdateSession.getLastUpdateSessionTime = function() {
            var dt = nsUpdateSession.ms2Time(nsUpdateSession.getLastUpdateSessionTimeMs());
            return dt;
        }

        // 设置客户端与服务器端的时间差
        nsUpdateSession.getTimeBetweenServerAndClient = function() {
            var clientTime = new Date();
            //var serverTimeStr = $.cookie(nsUpdateSession.LastUpdateSessionTimeCookieName);
            //var serverTime = new Date();
            //serverTime.setTime(Date.parse(serverTimeStr));
            var serverTime = nsUpdateSession.getLastUpdateSessionTimeMs();
            var timeBetweenServerAndClient = clientTime.getTime() - serverTime;
            return timeBetweenServerAndClient;
        }

        // 初始化定时间隔
        nsUpdateSession.initInterval = function() {
            // （比超时时间小30秒，如超时时间为20分钟，则更新时间定为19分半）
            nsUpdateSession.interval = nsUpdateSession.sessionWindow - nsUpdateSession.Minutes / 2;
            // test ========================================================Begin
            //var msg = $("#msg");
            //msg.append("初始化nsUpdateSession.interval = " + nsUpdateSession.interval + "<br />");
            // test ========================================================End
        }

        // 启动下一次定时
        nsUpdateSession.nextUpdate = function() {
            nsUpdateSession.updateSessionTimer = setTimeout(nsUpdateSession.updateSession, nsUpdateSession.interval);
        }

        // 停止自动发更新Session请求，为测试用
        nsUpdateSession.stopAutoUpdate = function() {
            clearTimeout(nsUpdateSession.updateSessionTimer);
            nsUpdateSession.isAutoUpdate = false;
            // test ========================================================Begin
            var msg = $("#msg");
            msg.append("<hr />");
            msg.append("已经停止自动更新<br />");
            msg.append("<hr />");
            // test ========================================================End
        }

        // 设置互斥体
        nsUpdateSession.setIsUpdatingSession = function(val) {
            $.cookie(nsUpdateSession.IsUpdatingSessionCookieName, val);
        }

        // 锁定多窗口互斥体
        nsUpdateSession.lockUpdateMutex = function() {
            nsUpdateSession.setIsUpdatingSession(true);
        }

        // 释放多窗口互斥体
        nsUpdateSession.releaseUpdateMutex = function() {
            nsUpdateSession.setIsUpdatingSession(false);
        }

        // 在状态栏显示正在更新Session
        nsUpdateSession.showUpdatingSessionMsg = function() {
            window.status = nsUpdateSession.UpdatingSessionMsg;
        }

        // 清除状态栏显示
        nsUpdateSession.hideUpdatingSessionMsg = function() {
            if (window.status == nsUpdateSession.UpdatingSessionMsg)
                window.status = "";
        }

        // tool functions ========================================================End

        // 发出更新请求
        nsUpdateSession.updateSession = function() {
            // test ========================================================Begin
            var msg = $("#msg");
            msg.append("<hr />");
            msg.append("进入updateSession，时间：" + new Date() + "<br />");
            // test ========================================================End
            // IsUpdatingSession用来互斥多窗口的更新操作
            var isUpdatingSession = nsUpdateSession.getIsUpdatingSession();
            if (!isUpdatingSession) { // 如果其它窗口没在更新
                // 锁定互斥体
                nsUpdateSession.lockUpdateMutex();
                // test ========================================================Begin
                msg.append("其它窗口没在更新<br />");
                // test ========================================================End
                var leftMs = nsUpdateSession.getLeftMs();
                var leftMinute = leftMs / nsUpdateSession.Minutes;

                if (leftMinute < 1) { // 有必要更新
                    // test ========================================================Begin
                    msg.append("距过期时间还有" + (leftMs / 1000) + "秒，小于1分钟，有必要更新<br />");
                    msg.append("开始请求<br />");
                    // test ========================================================End

                    // 发出更新请求
                    $.get("/UpdateSession", null, nsUpdateSession.onUpdateSessionComplete, "text");
                    nsUpdateSession.showUpdatingSessionMsg();
                }
                else {
                    // test ========================================================Begin
                    msg.append("距过期时间还有" + (leftMs / 1000) + "秒，大于等于1分钟，所以现在没必要更新<br />");
                    msg.append("<hr />");
                    // test ========================================================End
                    if (nsUpdateSession.isAutoUpdate) {
                        nsUpdateSession.interval = leftMs - nsUpdateSession.Minutes / 2;
                        nsUpdateSession.nextUpdate();
                    }
                    nsUpdateSession.releaseUpdateMutex();
                }
            }
            else { // 其它窗口正在更新
                // test ========================================================Begin
                msg.append("其它窗口正在更新，本次请求不必要<br />");
                msg.append("<hr />");
                // test ========================================================End
                if (nsUpdateSession.isAutoUpdate) {
                    nsUpdateSession.initInterval();
                    nsUpdateSession.nextUpdate();
                }
            }
        };

        // 当更新请求执行完毕时执行
        nsUpdateSession.onUpdateSessionComplete = function(result) {
            // 请求完毕时，释放互斥体
            nsUpdateSession.releaseUpdateMutex();
            nsUpdateSession.hideUpdatingSessionMsg();
            if (result.toString().toLowerCase() == "ok") { // 请求成功时
                if (nsUpdateSession.isAutoUpdate) {
                    nsUpdateSession.initInterval();
                    nsUpdateSession.nextUpdate();
                }
            }
            else { // 当请求出问题时
                alert("Session will timeout!" + result);
            }
            // test ========================================================Begin
            var msg = $("#msg");
            msg.append("结束请求时间：" + new Date() + "<br />");
            msg.append("请求结果：" + result + "<br />");
            msg.append("LastUpdateSessionTime = " + nsUpdateSession.getLastUpdateSessionTime() + "<br />");
            msg.append("<hr />");
            // test ========================================================End
        }

        // 页面ready时执行
        $(function() {
            // 设置常量
            nsUpdateSession.IsUpdatingSessionCookieName = "IsUpdatingSession";
            nsUpdateSession.LastUpdateSessionTimeCookieName = "LastUpdateSessionTime";
            nsUpdateSession.SessionWindowControlId = "sessionWindow";
            nsUpdateSession.Minutes = 1000 * 60;
            // 获取Session时间窗口（分钟）
            nsUpdateSession.sessionWindowMinute = (parseInt($("#" + nsUpdateSession.SessionWindowControlId).val()));
            nsUpdateSession.sessionWindow = nsUpdateSession.sessionWindowMinute * nsUpdateSession.Minutes;
            if (nsUpdateSession.sessionWindowMinute < 1) {
                alert("Session Window = '" + nsUpdateSession.sessionWindowMinute + "' Minutes, it's too low!");
                return;
            }
            // 是否自动定时更新
            nsUpdateSession.isAutoUpdate = true;
            // timeBetweenServerAndClient记录服务器时间与客户端时间的差值（毫秒)，服务器时间 = 客户端时间 - 这个值，这个值
            // 可以把传输时间忽略为0，这个值就代表服务器时间与客户时间之差，用于把客户端时间转换为服务器时间
            nsUpdateSession.timeBetweenServerAndClient = nsUpdateSession.getTimeBetweenServerAndClient();
            // 设置定时间隔
            nsUpdateSession.initInterval();
            // 启动定时器
            nsUpdateSession.nextUpdate();
            // 防止多窗口时，如果其中一个窗口正在更新，还没有结束之前被关闭，其它窗口就没办法更新的问题
            $(window).unload(nsUpdateSession.releaseUpdateMutex);
            // test ========================================================Begin
            var msg = $("#msg");
            msg.append("LastUpdateSessionTime = " + nsUpdateSession.getLastUpdateSessionTime() + "<br />");
            //msg.append("timeBetweenServerAndClient = " + nsUpdateSession.timeBetweenServerAndClient + "<br />");
            // test ========================================================End
        });
    </script>

</div>
<hr />
<div id="msg" style="background: #ffee73">
</div>
